#include <bits/stdc++.h>

using namespace std;

int basta[2005][2005];
int cnt[1000005];
bool mark[1000005];
int brojkonacnih;
int n,k;
int m,l;

void proveri(int red,int kol,int el)
{
    int br=0;
    
    for(int p=red;p<=l;p++)
    {
        for(int q=kol;q<=m;q++)
        {
            if(basta[p][q]==el)
            {
                br++;
            }
        }
    }
    
    if(br==cnt[el] && br==(l-red+1)*(m-kol+1)) brojkonacnih++;
}

int main() 
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cerr.tie(0);
    
    cin >> n >> k;
    
    brojkonacnih=0;
    
    for(int i=1;i<=k;i++)
    {
        mark[i]=false;
    }
    
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=n;j++)
        {
            cin >> basta[i][j];
            cnt[basta[i][j]]++;
        }
    }
    
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=n;j++)
        {
            if(!mark[basta[i][j]])
            {
                mark[basta[i][j]]=true;
                for(m=j+1;m<=n && basta[i][m]==basta[i][j];m++);
                m--;
                for(l=i+1;l<=n && basta[l][j]==basta[i][j];l++);
                l--;
                proveri(i,j,basta[i][j]);
            }
        }
    }
    
    cout << brojkonacnih;
    
    return 0;
}